<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		filedump
 */

class Hook_stats_filedump
{

	/**
	 * Standard modular run function.
	 *
	 * @return tempcode	The result of execution.
	 */
	function run()
	{
		if (!addon_installed('filedump')) return new ocp_tempcode();
		if (!file_exists(get_custom_file_base().'/uploads/filedump')) return new ocp_tempcode();

		require_lang('filedump');

		require_code('files2');

		$bits=new ocp_tempcode();
		if (get_option('filedump_show_stats_count_total_files',true)=='1') $bits->attach(do_template('BLOCK_SIDE_STATS_SUBLINE',array('KEY'=>do_lang_tempcode('COUNT_FILES'),'VALUE'=>integer_format(count(get_directory_contents(get_custom_file_base().'/uploads/filedump'))))));
		if (get_option('filedump_show_stats_count_total_space',true)=='1') $bits->attach(do_template('BLOCK_SIDE_STATS_SUBLINE',array('KEY'=>do_lang_tempcode('DISK_USAGE'),'VALUE'=>clean_file_size(get_directory_size(get_custom_file_base().'/uploads/filedump')))));
		if ($bits->is_definitely_empty()) return new ocp_tempcode();
		$section=do_template('BLOCK_SIDE_STATS_SECTION',array('SECTION'=>do_lang_tempcode('FILE_DUMP'),'CONTENT'=>$bits));

		return $section;
	}

}


